uniform mat4 u_Matrix;
uniform float u_Time;
uniform float a_PointSize_Random;

attribute vec3 a_Position;
attribute vec3 a_Color;
attribute vec3 a_DirectionVector;
attribute float a_ParticleStartTime;
attribute float a_PointSize;

varying vec3 v_Color;
varying float v_ElapsedTime;

void main()
{

    v_ElapsedTime = u_Time - a_ParticleStartTime;
    float size = a_PointSize;

    float speed = sqrt(v_ElapsedTime) * 1.3;

    if(speed>0.2){
        size = a_PointSize + a_PointSize * v_ElapsedTime + a_PointSize_Random;
    }

    if(speed >= 1.0) {
        speed = sqrt(speed);
    }

    if(speed >= 1.4) {
        size = sqrt(size * a_PointSize_Random);
    }

    vec3 currentPosition = a_Position + (a_DirectionVector * speed);

    v_Color = a_Color;
    gl_Position = u_Matrix * vec4(currentPosition, 1.0);
    gl_PointSize = size;
}   
