uniform mat4 u_Matrix;
uniform float u_Time;
uniform float a_PointSize_Random;

attribute vec3 a_Position;  
attribute vec3 a_Color;
attribute vec3 a_DirectionVector;
attribute float a_ParticleStartTime;
attribute float a_PointSize;

varying vec3 v_Color;
varying float v_ElapsedTime;

void main()                    
{                                	  	  
    v_Color = a_Color;
    v_ElapsedTime = u_Time - a_ParticleStartTime;

    float size = a_PointSize + a_PointSize * v_ElapsedTime * 1.5;

    vec3 currentPosition = a_Position + (a_DirectionVector * v_ElapsedTime);

    gl_Position = u_Matrix * vec4(currentPosition, 1.0);

    gl_PointSize = size;
}   
